﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, July 25, 2008 10:19:46 AM
// Code is generated using templates: SD.TemplateBindings.AccessSpecific.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Data.OleDb;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace LLBLGenTest.DatabaseSpecific
{
	/// <summary>
	/// Singleton implementation of the PersistenceInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.
	/// </summary>
	/// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the PersistenceInfoProviderBase class is threadsafe.</remarks>
	internal sealed class PersistenceInfoProviderSingleton
	{
		#region Class Member Declarations
		private static readonly IPersistenceInfoProvider _providerInstance = new PersistenceInfoProviderCore();
		#endregion
		
		/// <summary>private ctor to prevent instances of this class.</summary>
		private PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
		static PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Gets the singleton instance of the PersistenceInfoProviderCore</summary>
		/// <returns>Instance of the PersistenceInfoProvider.</returns>
		public static IPersistenceInfoProvider GetInstance()
		{
			return _providerInstance;
		}
	}

	/// <summary>Actual implementation of the PersistenceInfoProvider. Used by singleton wrapper.</summary>
	internal class PersistenceInfoProviderCore : PersistenceInfoProviderBase
	{
		/// <summary>Initializes a new instance of the <see cref="PersistenceInfoProviderCore"/> class.</summary>
		internal PersistenceInfoProviderCore()
		{
			Init();
		}

		/// <summary>Method which initializes the internal datastores with the structure of hierarchical types.</summary>
		private void Init()
		{
			base.InitClass((2 + 0));
			InitOrderDetailsEntityMappings();
			InitOrdersEntityMappings();

		}


		/// <summary>Inits OrderDetailsEntity's mappings</summary>
		private void InitOrderDetailsEntityMappings()
		{
			base.AddElementMapping( "OrderDetailsEntity", "Nwind", @"Default", "Order Details", 5 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "OrderId", "OrderID", true, (int)OleDbType.Integer, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "ProductId", "ProductID", false, (int)OleDbType.Integer, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "UnitPrice", "UnitPrice", false, (int)OleDbType.Currency, 0, 2, 19, false, "", null, typeof(System.Decimal), 2 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "Quantity", "Quantity", false, (int)OleDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 3 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "Discount", "Discount", false, (int)OleDbType.Single, 0, 0, 7, false, "", null, typeof(System.Single), 4 );
		}
		/// <summary>Inits OrdersEntity's mappings</summary>
		private void InitOrdersEntityMappings()
		{
			base.AddElementMapping( "OrdersEntity", "Nwind", @"Default", "Orders", 14 );
			base.AddElementFieldMapping( "OrdersEntity", "OrderId", "OrderID", false, (int)OleDbType.Integer, 0, 0, 10, true, "@@IDENTITY", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrdersEntity", "CustomerId", "CustomerID", true, (int)OleDbType.VarWChar, 5, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "OrdersEntity", "EmployeeId", "EmployeeID", true, (int)OleDbType.Integer, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
			base.AddElementFieldMapping( "OrdersEntity", "OrderDate", "OrderDate", true, (int)OleDbType.Date, 0, 0, 0, false, "", null, typeof(System.DateTime), 3 );
			base.AddElementFieldMapping( "OrdersEntity", "RequiredDate", "RequiredDate", true, (int)OleDbType.Date, 0, 0, 0, false, "", null, typeof(System.DateTime), 4 );
			base.AddElementFieldMapping( "OrdersEntity", "ShippedDate", "ShippedDate", true, (int)OleDbType.Date, 0, 0, 0, false, "", null, typeof(System.DateTime), 5 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipVia", "ShipVia", true, (int)OleDbType.Integer, 0, 0, 10, false, "", null, typeof(System.Int32), 6 );
			base.AddElementFieldMapping( "OrdersEntity", "Freight", "Freight", true, (int)OleDbType.Currency, 0, 2, 19, false, "", null, typeof(System.Decimal), 7 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipName", "ShipName", true, (int)OleDbType.VarWChar, 40, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipAddress", "ShipAddress", true, (int)OleDbType.VarWChar, 60, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipCity", "ShipCity", true, (int)OleDbType.VarWChar, 15, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipRegion", "ShipRegion", true, (int)OleDbType.VarWChar, 15, 0, 0, false, "", null, typeof(System.String), 11 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipPostalCode", "ShipPostalCode", true, (int)OleDbType.VarWChar, 10, 0, 0, false, "", null, typeof(System.String), 12 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipCountry", "ShipCountry", true, (int)OleDbType.VarWChar, 15, 0, 0, false, "", null, typeof(System.String), 13 );
		}

	}
}
