﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, July 25, 2008 10:19:45 AM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.ComponentModel;
using System.Data;
using System.Collections;
#if !CF
using System.Runtime.Serialization;
#endif

using LLBLGenTest.EntityClasses;
using LLBLGenTest.HelperClasses;
using LLBLGenTest.FactoryClasses;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace LLBLGenTest.TypedListClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	

	/// <summary>
	/// Typed datatable for the list 'OrderDetails'.<br/><br/>
	/// 
	/// </summary>
	/// <remarks>
	/// The code doesn't support any changing of data. Users who do that are on their own.
	/// It also doesn't support any event throwing. This list should be used as a base for readonly databinding
	/// or dataview construction.
	/// </remarks>
#if !CF	
	[Serializable, System.ComponentModel.DesignerCategory("Code")]
	[ToolboxItem(true)]
	[DesignTimeVisible(true)]
#endif	
	public partial class OrderDetailsTypedList : TypedListBase2<OrderDetailsRow>, ITypedListLgp2
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfacesList
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private DataColumn _columnOrderId;
		private DataColumn _columnProductId;
		private DataColumn _columnQuantity;
		private DataColumn _columnUnitPrice;
		private DataColumn _columnDiscount;
		private ResultsetFields _fields;
		private IRelationPredicateBucket _filterBucket;
		
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalMembers
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		private static Hashtable	_customProperties;
		private static Hashtable	_fieldsCustomProperties;
		#endregion

		#region Class Constants
		/// <summary>The amount of fields in the resultset.</summary>
		private const int AmountOfFields = 5;
		#endregion


		/// <summary>Static CTor for setting up custom property hashtables. Is executed before the first instance of this
		/// class or derived classes is constructed. </summary>
		static OrderDetailsTypedList()
		{
			SetupCustomPropertyHashtables();
		}
		

		/// <summary>CTor</summary>
		public OrderDetailsTypedList():base("OrderDetails")
		{
			InitClass(false);
		}
		
		
		/// <summary>CTor</summary>
		/// <param name="obeyWeakRelations">The flag to signal the collection what kind of join statements to generate in the
		/// query statement. Weak relationships are relationships which are optional, for example a
		/// customer with no orders is possible, because the relationship between customer and order is based on a field in order.
		/// When this property is set to true (default: false), weak relationships will result in LEFT JOIN statements. When
		/// set to false (which is the default), INNER JOIN statements are used.
		/// </param>
		public OrderDetailsTypedList(bool obeyWeakRelations):base("OrderDetails")
		{
			InitClass(obeyWeakRelations);
		}
		
		
#if !CF	
		/// <summary>Protected constructor for deserialization.</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		protected OrderDetailsTypedList(SerializationInfo info, StreamingContext context):base(info, context)
		{
			if(SerializationHelper.Optimization == SerializationOptimization.None)
			{
				InitMembers();
				BuildResultset();
			}
		}
#endif		

		/// <summary>Gets the IEntityFields2 collection of fields of this typed list. Use this method in combination with the FetchTypedList() methods in 
		/// DataAccessAdapter.</summary>
		/// <returns>Ready to use IEntityFields2 collection object.</returns>
		public virtual IEntityFields2 GetFieldsInfo()
		{
			return _fields;
		}


		/// <summary>Gets the IRelationPredicateBucket object which contains the relation information for this Typed List. Use this method in combination with the 
		/// FetchTypedList() methods in DataAccessAdapter.</summary>
		/// <returns>Ready to use IRelationPredicateBucket object.</returns>
		public virtual IRelationPredicateBucket GetRelationInfo()
		{
			_filterBucket = new RelationPredicateBucket();
			BuildRelationSet();
			return _filterBucket;
		}

		/// <summary>Creates a new typed row during the build of the datatable during a Fill session by a dataadapter.</summary>
		/// <param name="rowBuilder">supplied row builder to pass to the typed row</param>
		/// <returns>the new typed datarow</returns>
		protected override DataRow NewRowFromBuilder(DataRowBuilder rowBuilder) 
		{
			return new OrderDetailsRow(rowBuilder);
		}


		/// <summary>Initializes the hashtables for the typed list type and typed list field custom properties. </summary>
		private static void SetupCustomPropertyHashtables()
		{
			_customProperties = new Hashtable();
			_fieldsCustomProperties = new Hashtable();

			Hashtable fieldHashtable = null;

			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("OrderId", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("ProductId", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("Quantity", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("UnitPrice", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("Discount", fieldHashtable);			
		}


		/// <summary>Builds the relation set for this typed list, inside the filterBucket object.</summary>
		private void BuildRelationSet()
		{
			_filterBucket.Relations.ObeyWeakRelations = base.ObeyWeakRelations;

			
			// __LLBLGENPRO_USER_CODE_REGION_START AdditionalRelations
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnRelationSetBuilt(_filterBucket.Relations);
		}


		/// <summary>Builds the resultset fields, stored in the private _fields object</summary>
		private void BuildResultset()
		{
			_fields = new ResultsetFields(AmountOfFields);
			_fields.DefineField(OrderDetailsFields.OrderId, 0, "OrderId", "", AggregateFunction.None);
			_fields.DefineField(OrderDetailsFields.ProductId, 1, "ProductId", "", AggregateFunction.None);
			_fields.DefineField(OrderDetailsFields.Quantity, 2, "Quantity", "", AggregateFunction.None);
			_fields.DefineField(OrderDetailsFields.UnitPrice, 3, "UnitPrice", "", AggregateFunction.None);
			_fields.DefineField(OrderDetailsFields.Discount, 4, "Discount", "", AggregateFunction.None);
			
			// __LLBLGENPRO_USER_CODE_REGION_START AdditionalFields
			// be sure to call _fields.Expand(number of new fields) first. 
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnResultsetBuilt(_fields);
		}


		/// <summary>Initialize the datastructures.</summary>
		/// <param name="obeyWeakRelations">flag for the internal used relations object</param>
		protected override void InitClass(bool obeyWeakRelations)
		{
			TableName = "OrderDetails";		
			base.ObeyWeakRelations = obeyWeakRelations;

			_columnOrderId = new DataColumn("OrderId", typeof(System.Int32), null, MappingType.Element);
			_columnOrderId.ReadOnly = true;
			_columnOrderId.Caption = @"OrderId";
			this.Columns.Add(_columnOrderId);
			_columnProductId = new DataColumn("ProductId", typeof(System.Int32), null, MappingType.Element);
			_columnProductId.ReadOnly = true;
			_columnProductId.Caption = @"ProductId";
			this.Columns.Add(_columnProductId);
			_columnQuantity = new DataColumn("Quantity", typeof(System.Int16), null, MappingType.Element);
			_columnQuantity.ReadOnly = true;
			_columnQuantity.Caption = @"Quantity";
			this.Columns.Add(_columnQuantity);
			_columnUnitPrice = new DataColumn("UnitPrice", typeof(System.Decimal), null, MappingType.Element);
			_columnUnitPrice.ReadOnly = true;
			_columnUnitPrice.Caption = @"UnitPrice";
			this.Columns.Add(_columnUnitPrice);
			_columnDiscount = new DataColumn("Discount", typeof(System.Single), null, MappingType.Element);
			_columnDiscount.ReadOnly = true;
			_columnDiscount.Caption = @"Discount";
			this.Columns.Add(_columnDiscount);
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClass
			// __LLBLGENPRO_USER_CODE_REGION_END
			

			BuildResultset();
			_filterBucket = new RelationPredicateBucket();
			BuildRelationSet();
			OnInitialized();
		}


		/// <summary>Initializes the members, after a clone action.</summary>
		private void InitMembers()
		{
			_columnOrderId = this.Columns["OrderId"];
			_columnProductId = this.Columns["ProductId"];
			_columnQuantity = this.Columns["Quantity"];
			_columnUnitPrice = this.Columns["UnitPrice"];
			_columnDiscount = this.Columns["Discount"];
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitMembers
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnInitialized();
		}


		/// <summary>Return the type of the typed datarow</summary>
		/// <returns>returns the requested type</returns>
		protected override Type GetRowType() 
		{
			return typeof(OrderDetailsRow);
		}


		/// <summary>Clones this instance.</summary>
		/// <returns>A clone of this instance</returns>
		public override DataTable Clone() 
		{
			OrderDetailsTypedList cloneToReturn = ((OrderDetailsTypedList)(base.Clone()));
			cloneToReturn.InitMembers();
			return cloneToReturn;
		}
		
#if !CF
		/// <summary>Creates a new instance of the DataTable class.</summary>
		/// <returns>a new instance of a datatable with this schema.</returns>
		protected override DataTable CreateInstance() 
		{
			return new OrderDetailsTypedList();
		}
#endif

		#region Class Property Declarations
		/// <summary>Returns the amount of rows in this typed list.</summary>
		[System.ComponentModel.Browsable(false)]
		public override int Count 
		{
			get 
			{
				return this.Rows.Count;
			}
		}
		
		/// <summary>The custom properties for this TypedList type.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public static Hashtable CustomProperties
		{
			get { return _customProperties;}
		}

		/// <summary>The custom properties for the type of this TypedList instance.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[System.ComponentModel.Browsable(false)]
		public virtual Hashtable CustomPropertiesOfType
		{
			get { return OrderDetailsTypedList.CustomProperties;}
		}

		/// <summary>The custom properties for the fields of this TypedList type. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public static Hashtable FieldsCustomProperties
		{
			get { return _fieldsCustomProperties;}
		}

		/// <summary>The custom properties for the fields of the type of this TypedList instance. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[System.ComponentModel.Browsable(false)]
		public virtual Hashtable FieldsCustomPropertiesOfType
		{
			get { return OrderDetailsTypedList.FieldsCustomProperties;}
		}

		/// <summary>Indexer of this strong typed list</summary>
		public OrderDetailsRow this[int index] 
		{
			get 
			{
				return ((OrderDetailsRow)(this.Rows[index]));
			}
		}
		
		/// <summary>Gets an array of all OrderDetailsRow objects.</summary>
		/// <returns>Array with OrderDetailsRow objects</returns>
		public new OrderDetailsRow[] Select()
		{
			return (OrderDetailsRow[])base.Select();
		}


		/// <summary>Gets an array of all OrderDetailsRow objects that match the filter criteria in order of primary key (or lacking one, order of addition.) </summary>
		/// <param name="filterExpression">The criteria to use to filter the rows.</param>
		/// <returns>Array with OrderDetailsRow objects</returns>
		public new OrderDetailsRow[] Select(string filterExpression)
		{
			return (OrderDetailsRow[])base.Select(filterExpression);
		}


		/// <summary>Gets an array of all OrderDetailsRow objects that match the filter criteria, in the specified sort order</summary>
		/// <param name="filterExpression">The filter expression.</param>
		/// <param name="sort">A string specifying the column and sort direction.</param>
		/// <returns>Array with OrderDetailsRow objects</returns>
		public new OrderDetailsRow[] Select(string filterExpression, string sort)
		{
			return (OrderDetailsRow[])base.Select(filterExpression, sort);
		}


		/// <summary>Gets an array of all OrderDetailsRow objects that match the filter criteria, in the specified sort order that match the specified state</summary>
		/// <param name="filterExpression">The filter expression.</param>
		/// <param name="sort">A string specifying the column and sort direction.</param>
		/// <param name="recordStates">One of the <see cref="System.Data.DataViewRowState"/> values.</param>
		/// <returns>Array with OrderDetailsRow objects</returns>
		public new OrderDetailsRow[] Select(string filterExpression, string sort, DataViewRowState recordStates)
		{
			return (OrderDetailsRow[])base.Select(filterExpression, sort, recordStates);
		}

	
		/// <summary>Returns the column object belonging to the TypedList field OrderId</summary>
		internal DataColumn OrderIdColumn 
		{
			get { return _columnOrderId; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field ProductId</summary>
		internal DataColumn ProductIdColumn 
		{
			get { return _columnProductId; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field Quantity</summary>
		internal DataColumn QuantityColumn 
		{
			get { return _columnQuantity; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field UnitPrice</summary>
		internal DataColumn UnitPriceColumn 
		{
			get { return _columnUnitPrice; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field Discount</summary>
		internal DataColumn DiscountColumn 
		{
			get { return _columnDiscount; }
		}
    
		
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalColumnProperties
		// __LLBLGENPRO_USER_CODE_REGION_END
		
 		#endregion

		#region Custom TypedList code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomTypedListCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Included Code

		#endregion
	}


	/// <summary>
	/// Typed datarow for the typed datatable OrderDetails
	/// </summary>
	public partial class OrderDetailsRow : DataRow
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfacesRow
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private OrderDetailsTypedList	_parent;
		#endregion

		/// <summary>CTor</summary>
		/// <param name="rowBuilder">Row builder object to use when building this row</param>
		protected internal OrderDetailsRow(DataRowBuilder rowBuilder) : base(rowBuilder) 
		{
			_parent = ((OrderDetailsTypedList)(this.Table));
		}


		#region Class Property Declarations
	
		/// <summary>Gets / sets the value of the TypedList field OrderId<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: OrderDetails.OrderId</remarks>
		public System.Int32 OrderId 
		{
			get 
			{
				if(IsOrderIdNull())
				{
					return (System.Int32)TypeDefaultValue.GetDefaultValue(typeof(System.Int32));
				}
				else
				{
					return (System.Int32)this[_parent.OrderIdColumn];
				}
			}
			set 
			{
				this[_parent.OrderIdColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field OrderId is NULL, false otherwise.</summary>
		public bool IsOrderIdNull() 
		{
			return IsNull(_parent.OrderIdColumn);
		}

		/// <summary>Sets the TypedList field OrderId to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetOrderIdNull() 
		{
			this[_parent.OrderIdColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field ProductId<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: OrderDetails.ProductId</remarks>
		public System.Int32 ProductId 
		{
			get 
			{
				if(IsProductIdNull())
				{
					return (System.Int32)TypeDefaultValue.GetDefaultValue(typeof(System.Int32));
				}
				else
				{
					return (System.Int32)this[_parent.ProductIdColumn];
				}
			}
			set 
			{
				this[_parent.ProductIdColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field ProductId is NULL, false otherwise.</summary>
		public bool IsProductIdNull() 
		{
			return IsNull(_parent.ProductIdColumn);
		}

		/// <summary>Sets the TypedList field ProductId to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetProductIdNull() 
		{
			this[_parent.ProductIdColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field Quantity<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: OrderDetails.Quantity</remarks>
		public System.Int16 Quantity 
		{
			get 
			{
				if(IsQuantityNull())
				{
					return (System.Int16)TypeDefaultValue.GetDefaultValue(typeof(System.Int16));
				}
				else
				{
					return (System.Int16)this[_parent.QuantityColumn];
				}
			}
			set 
			{
				this[_parent.QuantityColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field Quantity is NULL, false otherwise.</summary>
		public bool IsQuantityNull() 
		{
			return IsNull(_parent.QuantityColumn);
		}

		/// <summary>Sets the TypedList field Quantity to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetQuantityNull() 
		{
			this[_parent.QuantityColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field UnitPrice<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: OrderDetails.UnitPrice</remarks>
		public System.Decimal UnitPrice 
		{
			get 
			{
				if(IsUnitPriceNull())
				{
					return (System.Decimal)TypeDefaultValue.GetDefaultValue(typeof(System.Decimal));
				}
				else
				{
					return (System.Decimal)this[_parent.UnitPriceColumn];
				}
			}
			set 
			{
				this[_parent.UnitPriceColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field UnitPrice is NULL, false otherwise.</summary>
		public bool IsUnitPriceNull() 
		{
			return IsNull(_parent.UnitPriceColumn);
		}

		/// <summary>Sets the TypedList field UnitPrice to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetUnitPriceNull() 
		{
			this[_parent.UnitPriceColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field Discount<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: OrderDetails.Discount</remarks>
		public System.Single Discount 
		{
			get 
			{
				if(IsDiscountNull())
				{
					return (System.Single)TypeDefaultValue.GetDefaultValue(typeof(System.Single));
				}
				else
				{
					return (System.Single)this[_parent.DiscountColumn];
				}
			}
			set 
			{
				this[_parent.DiscountColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field Discount is NULL, false otherwise.</summary>
		public bool IsDiscountNull() 
		{
			return IsNull(_parent.DiscountColumn);
		}

		/// <summary>Sets the TypedList field Discount to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetDiscountNull() 
		{
			this[_parent.DiscountColumn] = System.Convert.DBNull;
		}

	
		#endregion

		#region Custom Typed List Row Code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomTypedListRowCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion
	}
}
