﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, July 25, 2008 10:19:45 AM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.ComponentModel;
using System.Data;
using System.Collections;
#if !CF
using System.Runtime.Serialization;
#endif

using LLBLGenTest.EntityClasses;
using LLBLGenTest.HelperClasses;
using LLBLGenTest.FactoryClasses;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace LLBLGenTest.TypedListClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	

	/// <summary>
	/// Typed datatable for the list 'Orders'.<br/><br/>
	/// 
	/// </summary>
	/// <remarks>
	/// The code doesn't support any changing of data. Users who do that are on their own.
	/// It also doesn't support any event throwing. This list should be used as a base for readonly databinding
	/// or dataview construction.
	/// </remarks>
#if !CF	
	[Serializable, System.ComponentModel.DesignerCategory("Code")]
	[ToolboxItem(true)]
	[DesignTimeVisible(true)]
#endif	
	public partial class OrdersTypedList : TypedListBase2<OrdersRow>, ITypedListLgp2
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfacesList
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private DataColumn _columnOrderId;
		private DataColumn _columnCustomerId;
		private DataColumn _columnEmployeeId;
		private DataColumn _columnOrderDate;
		private DataColumn _columnShipPostalCode;
		private DataColumn _columnShipCountry;
		private DataColumn _columnShipCity;
		private ResultsetFields _fields;
		private IRelationPredicateBucket _filterBucket;
		
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalMembers
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		private static Hashtable	_customProperties;
		private static Hashtable	_fieldsCustomProperties;
		#endregion

		#region Class Constants
		/// <summary>The amount of fields in the resultset.</summary>
		private const int AmountOfFields = 7;
		#endregion


		/// <summary>Static CTor for setting up custom property hashtables. Is executed before the first instance of this
		/// class or derived classes is constructed. </summary>
		static OrdersTypedList()
		{
			SetupCustomPropertyHashtables();
		}
		

		/// <summary>CTor</summary>
		public OrdersTypedList():base("Orders")
		{
			InitClass(false);
		}
		
		
		/// <summary>CTor</summary>
		/// <param name="obeyWeakRelations">The flag to signal the collection what kind of join statements to generate in the
		/// query statement. Weak relationships are relationships which are optional, for example a
		/// customer with no orders is possible, because the relationship between customer and order is based on a field in order.
		/// When this property is set to true (default: false), weak relationships will result in LEFT JOIN statements. When
		/// set to false (which is the default), INNER JOIN statements are used.
		/// </param>
		public OrdersTypedList(bool obeyWeakRelations):base("Orders")
		{
			InitClass(obeyWeakRelations);
		}
		
		
#if !CF	
		/// <summary>Protected constructor for deserialization.</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		protected OrdersTypedList(SerializationInfo info, StreamingContext context):base(info, context)
		{
			if(SerializationHelper.Optimization == SerializationOptimization.None)
			{
				InitMembers();
				BuildResultset();
			}
		}
#endif		

		/// <summary>Gets the IEntityFields2 collection of fields of this typed list. Use this method in combination with the FetchTypedList() methods in 
		/// DataAccessAdapter.</summary>
		/// <returns>Ready to use IEntityFields2 collection object.</returns>
		public virtual IEntityFields2 GetFieldsInfo()
		{
			return _fields;
		}


		/// <summary>Gets the IRelationPredicateBucket object which contains the relation information for this Typed List. Use this method in combination with the 
		/// FetchTypedList() methods in DataAccessAdapter.</summary>
		/// <returns>Ready to use IRelationPredicateBucket object.</returns>
		public virtual IRelationPredicateBucket GetRelationInfo()
		{
			_filterBucket = new RelationPredicateBucket();
			BuildRelationSet();
			return _filterBucket;
		}

		/// <summary>Creates a new typed row during the build of the datatable during a Fill session by a dataadapter.</summary>
		/// <param name="rowBuilder">supplied row builder to pass to the typed row</param>
		/// <returns>the new typed datarow</returns>
		protected override DataRow NewRowFromBuilder(DataRowBuilder rowBuilder) 
		{
			return new OrdersRow(rowBuilder);
		}


		/// <summary>Initializes the hashtables for the typed list type and typed list field custom properties. </summary>
		private static void SetupCustomPropertyHashtables()
		{
			_customProperties = new Hashtable();
			_fieldsCustomProperties = new Hashtable();

			Hashtable fieldHashtable = null;

			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("OrderId", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("CustomerId", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("EmployeeId", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("OrderDate", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("ShipPostalCode", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("ShipCountry", fieldHashtable);
			fieldHashtable = new Hashtable();

			_fieldsCustomProperties.Add("ShipCity", fieldHashtable);			
		}


		/// <summary>Builds the relation set for this typed list, inside the filterBucket object.</summary>
		private void BuildRelationSet()
		{
			_filterBucket.Relations.ObeyWeakRelations = base.ObeyWeakRelations;

			
			// __LLBLGENPRO_USER_CODE_REGION_START AdditionalRelations
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnRelationSetBuilt(_filterBucket.Relations);
		}


		/// <summary>Builds the resultset fields, stored in the private _fields object</summary>
		private void BuildResultset()
		{
			_fields = new ResultsetFields(AmountOfFields);
			_fields.DefineField(OrdersFields.OrderId, 0, "OrderId", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.CustomerId, 1, "CustomerId", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.EmployeeId, 2, "EmployeeId", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.OrderDate, 3, "OrderDate", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.ShipPostalCode, 4, "ShipPostalCode", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.ShipCountry, 5, "ShipCountry", "", AggregateFunction.None);
			_fields.DefineField(OrdersFields.ShipCity, 6, "ShipCity", "", AggregateFunction.None);
			
			// __LLBLGENPRO_USER_CODE_REGION_START AdditionalFields
			// be sure to call _fields.Expand(number of new fields) first. 
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnResultsetBuilt(_fields);
		}


		/// <summary>Initialize the datastructures.</summary>
		/// <param name="obeyWeakRelations">flag for the internal used relations object</param>
		protected override void InitClass(bool obeyWeakRelations)
		{
			TableName = "Orders";		
			base.ObeyWeakRelations = obeyWeakRelations;

			_columnOrderId = new DataColumn("OrderId", typeof(System.Int32), null, MappingType.Element);
			_columnOrderId.ReadOnly = true;
			_columnOrderId.Caption = @"OrderId";
			this.Columns.Add(_columnOrderId);
			_columnCustomerId = new DataColumn("CustomerId", typeof(System.String), null, MappingType.Element);
			_columnCustomerId.ReadOnly = true;
			_columnCustomerId.Caption = @"CustomerId";
			this.Columns.Add(_columnCustomerId);
			_columnEmployeeId = new DataColumn("EmployeeId", typeof(System.Int32), null, MappingType.Element);
			_columnEmployeeId.ReadOnly = true;
			_columnEmployeeId.Caption = @"EmployeeId";
			this.Columns.Add(_columnEmployeeId);
			_columnOrderDate = new DataColumn("OrderDate", typeof(System.DateTime), null, MappingType.Element);
			_columnOrderDate.ReadOnly = true;
			_columnOrderDate.Caption = @"OrderDate";
			this.Columns.Add(_columnOrderDate);
			_columnShipPostalCode = new DataColumn("ShipPostalCode", typeof(System.String), null, MappingType.Element);
			_columnShipPostalCode.ReadOnly = true;
			_columnShipPostalCode.Caption = @"ShipPostalCode";
			this.Columns.Add(_columnShipPostalCode);
			_columnShipCountry = new DataColumn("ShipCountry", typeof(System.String), null, MappingType.Element);
			_columnShipCountry.ReadOnly = true;
			_columnShipCountry.Caption = @"ShipCountry";
			this.Columns.Add(_columnShipCountry);
			_columnShipCity = new DataColumn("ShipCity", typeof(System.String), null, MappingType.Element);
			_columnShipCity.ReadOnly = true;
			_columnShipCity.Caption = @"ShipCity";
			this.Columns.Add(_columnShipCity);
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClass
			// __LLBLGENPRO_USER_CODE_REGION_END
			

			BuildResultset();
			_filterBucket = new RelationPredicateBucket();
			BuildRelationSet();
			OnInitialized();
		}


		/// <summary>Initializes the members, after a clone action.</summary>
		private void InitMembers()
		{
			_columnOrderId = this.Columns["OrderId"];
			_columnCustomerId = this.Columns["CustomerId"];
			_columnEmployeeId = this.Columns["EmployeeId"];
			_columnOrderDate = this.Columns["OrderDate"];
			_columnShipPostalCode = this.Columns["ShipPostalCode"];
			_columnShipCountry = this.Columns["ShipCountry"];
			_columnShipCity = this.Columns["ShipCity"];
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitMembers
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnInitialized();
		}


		/// <summary>Return the type of the typed datarow</summary>
		/// <returns>returns the requested type</returns>
		protected override Type GetRowType() 
		{
			return typeof(OrdersRow);
		}


		/// <summary>Clones this instance.</summary>
		/// <returns>A clone of this instance</returns>
		public override DataTable Clone() 
		{
			OrdersTypedList cloneToReturn = ((OrdersTypedList)(base.Clone()));
			cloneToReturn.InitMembers();
			return cloneToReturn;
		}
		
#if !CF
		/// <summary>Creates a new instance of the DataTable class.</summary>
		/// <returns>a new instance of a datatable with this schema.</returns>
		protected override DataTable CreateInstance() 
		{
			return new OrdersTypedList();
		}
#endif

		#region Class Property Declarations
		/// <summary>Returns the amount of rows in this typed list.</summary>
		[System.ComponentModel.Browsable(false)]
		public override int Count 
		{
			get 
			{
				return this.Rows.Count;
			}
		}
		
		/// <summary>The custom properties for this TypedList type.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public static Hashtable CustomProperties
		{
			get { return _customProperties;}
		}

		/// <summary>The custom properties for the type of this TypedList instance.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[System.ComponentModel.Browsable(false)]
		public virtual Hashtable CustomPropertiesOfType
		{
			get { return OrdersTypedList.CustomProperties;}
		}

		/// <summary>The custom properties for the fields of this TypedList type. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public static Hashtable FieldsCustomProperties
		{
			get { return _fieldsCustomProperties;}
		}

		/// <summary>The custom properties for the fields of the type of this TypedList instance. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[System.ComponentModel.Browsable(false)]
		public virtual Hashtable FieldsCustomPropertiesOfType
		{
			get { return OrdersTypedList.FieldsCustomProperties;}
		}

		/// <summary>Indexer of this strong typed list</summary>
		public OrdersRow this[int index] 
		{
			get 
			{
				return ((OrdersRow)(this.Rows[index]));
			}
		}
		
		/// <summary>Gets an array of all OrdersRow objects.</summary>
		/// <returns>Array with OrdersRow objects</returns>
		public new OrdersRow[] Select()
		{
			return (OrdersRow[])base.Select();
		}


		/// <summary>Gets an array of all OrdersRow objects that match the filter criteria in order of primary key (or lacking one, order of addition.) </summary>
		/// <param name="filterExpression">The criteria to use to filter the rows.</param>
		/// <returns>Array with OrdersRow objects</returns>
		public new OrdersRow[] Select(string filterExpression)
		{
			return (OrdersRow[])base.Select(filterExpression);
		}


		/// <summary>Gets an array of all OrdersRow objects that match the filter criteria, in the specified sort order</summary>
		/// <param name="filterExpression">The filter expression.</param>
		/// <param name="sort">A string specifying the column and sort direction.</param>
		/// <returns>Array with OrdersRow objects</returns>
		public new OrdersRow[] Select(string filterExpression, string sort)
		{
			return (OrdersRow[])base.Select(filterExpression, sort);
		}


		/// <summary>Gets an array of all OrdersRow objects that match the filter criteria, in the specified sort order that match the specified state</summary>
		/// <param name="filterExpression">The filter expression.</param>
		/// <param name="sort">A string specifying the column and sort direction.</param>
		/// <param name="recordStates">One of the <see cref="System.Data.DataViewRowState"/> values.</param>
		/// <returns>Array with OrdersRow objects</returns>
		public new OrdersRow[] Select(string filterExpression, string sort, DataViewRowState recordStates)
		{
			return (OrdersRow[])base.Select(filterExpression, sort, recordStates);
		}

	
		/// <summary>Returns the column object belonging to the TypedList field OrderId</summary>
		internal DataColumn OrderIdColumn 
		{
			get { return _columnOrderId; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field CustomerId</summary>
		internal DataColumn CustomerIdColumn 
		{
			get { return _columnCustomerId; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field EmployeeId</summary>
		internal DataColumn EmployeeIdColumn 
		{
			get { return _columnEmployeeId; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field OrderDate</summary>
		internal DataColumn OrderDateColumn 
		{
			get { return _columnOrderDate; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field ShipPostalCode</summary>
		internal DataColumn ShipPostalCodeColumn 
		{
			get { return _columnShipPostalCode; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field ShipCountry</summary>
		internal DataColumn ShipCountryColumn 
		{
			get { return _columnShipCountry; }
		}
    
		/// <summary>Returns the column object belonging to the TypedList field ShipCity</summary>
		internal DataColumn ShipCityColumn 
		{
			get { return _columnShipCity; }
		}
    
		
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalColumnProperties
		// __LLBLGENPRO_USER_CODE_REGION_END
		
 		#endregion

		#region Custom TypedList code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomTypedListCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Included Code

		#endregion
	}


	/// <summary>
	/// Typed datarow for the typed datatable Orders
	/// </summary>
	public partial class OrdersRow : DataRow
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfacesRow
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private OrdersTypedList	_parent;
		#endregion

		/// <summary>CTor</summary>
		/// <param name="rowBuilder">Row builder object to use when building this row</param>
		protected internal OrdersRow(DataRowBuilder rowBuilder) : base(rowBuilder) 
		{
			_parent = ((OrdersTypedList)(this.Table));
		}


		#region Class Property Declarations
	
		/// <summary>Gets / sets the value of the TypedList field OrderId<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.OrderId</remarks>
		public System.Int32 OrderId 
		{
			get 
			{
				if(IsOrderIdNull())
				{
					return (System.Int32)TypeDefaultValue.GetDefaultValue(typeof(System.Int32));
				}
				else
				{
					return (System.Int32)this[_parent.OrderIdColumn];
				}
			}
			set 
			{
				this[_parent.OrderIdColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field OrderId is NULL, false otherwise.</summary>
		public bool IsOrderIdNull() 
		{
			return IsNull(_parent.OrderIdColumn);
		}

		/// <summary>Sets the TypedList field OrderId to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetOrderIdNull() 
		{
			this[_parent.OrderIdColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field CustomerId<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.CustomerId</remarks>
		public System.String CustomerId 
		{
			get 
			{
				if(IsCustomerIdNull())
				{
					return (System.String)TypeDefaultValue.GetDefaultValue(typeof(System.String));
				}
				else
				{
					return (System.String)this[_parent.CustomerIdColumn];
				}
			}
			set 
			{
				this[_parent.CustomerIdColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field CustomerId is NULL, false otherwise.</summary>
		public bool IsCustomerIdNull() 
		{
			return IsNull(_parent.CustomerIdColumn);
		}

		/// <summary>Sets the TypedList field CustomerId to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetCustomerIdNull() 
		{
			this[_parent.CustomerIdColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field EmployeeId<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.EmployeeId</remarks>
		public System.Int32 EmployeeId 
		{
			get 
			{
				if(IsEmployeeIdNull())
				{
					return (System.Int32)TypeDefaultValue.GetDefaultValue(typeof(System.Int32));
				}
				else
				{
					return (System.Int32)this[_parent.EmployeeIdColumn];
				}
			}
			set 
			{
				this[_parent.EmployeeIdColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field EmployeeId is NULL, false otherwise.</summary>
		public bool IsEmployeeIdNull() 
		{
			return IsNull(_parent.EmployeeIdColumn);
		}

		/// <summary>Sets the TypedList field EmployeeId to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetEmployeeIdNull() 
		{
			this[_parent.EmployeeIdColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field OrderDate<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.OrderDate</remarks>
		public System.DateTime OrderDate 
		{
			get 
			{
				if(IsOrderDateNull())
				{
					return (System.DateTime)TypeDefaultValue.GetDefaultValue(typeof(System.DateTime));
				}
				else
				{
					return (System.DateTime)this[_parent.OrderDateColumn];
				}
			}
			set 
			{
				this[_parent.OrderDateColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field OrderDate is NULL, false otherwise.</summary>
		public bool IsOrderDateNull() 
		{
			return IsNull(_parent.OrderDateColumn);
		}

		/// <summary>Sets the TypedList field OrderDate to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetOrderDateNull() 
		{
			this[_parent.OrderDateColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field ShipPostalCode<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.ShipPostalCode</remarks>
		public System.String ShipPostalCode 
		{
			get 
			{
				if(IsShipPostalCodeNull())
				{
					return (System.String)TypeDefaultValue.GetDefaultValue(typeof(System.String));
				}
				else
				{
					return (System.String)this[_parent.ShipPostalCodeColumn];
				}
			}
			set 
			{
				this[_parent.ShipPostalCodeColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field ShipPostalCode is NULL, false otherwise.</summary>
		public bool IsShipPostalCodeNull() 
		{
			return IsNull(_parent.ShipPostalCodeColumn);
		}

		/// <summary>Sets the TypedList field ShipPostalCode to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetShipPostalCodeNull() 
		{
			this[_parent.ShipPostalCodeColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field ShipCountry<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.ShipCountry</remarks>
		public System.String ShipCountry 
		{
			get 
			{
				if(IsShipCountryNull())
				{
					return (System.String)TypeDefaultValue.GetDefaultValue(typeof(System.String));
				}
				else
				{
					return (System.String)this[_parent.ShipCountryColumn];
				}
			}
			set 
			{
				this[_parent.ShipCountryColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field ShipCountry is NULL, false otherwise.</summary>
		public bool IsShipCountryNull() 
		{
			return IsNull(_parent.ShipCountryColumn);
		}

		/// <summary>Sets the TypedList field ShipCountry to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetShipCountryNull() 
		{
			this[_parent.ShipCountryColumn] = System.Convert.DBNull;
		}

	

		/// <summary>Gets / sets the value of the TypedList field ShipCity<br/><br/>
		/// </summary>
		/// <remarks>Mapped on: Orders.ShipCity</remarks>
		public System.String ShipCity 
		{
			get 
			{
				if(IsShipCityNull())
				{
					return (System.String)TypeDefaultValue.GetDefaultValue(typeof(System.String));
				}
				else
				{
					return (System.String)this[_parent.ShipCityColumn];
				}
			}
			set 
			{
				this[_parent.ShipCityColumn] = value;
			}
		}

		/// <summary>Returns true if the TypedList field ShipCity is NULL, false otherwise.</summary>
		public bool IsShipCityNull() 
		{
			return IsNull(_parent.ShipCityColumn);
		}

		/// <summary>Sets the TypedList field ShipCity to NULL. Not recommended; a typed list should be used as a readonly object.</summary>
    	public void SetShipCityNull() 
		{
			this[_parent.ShipCityColumn] = System.Convert.DBNull;
		}

	
		#endregion

		#region Custom Typed List Row Code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomTypedListRowCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion
	}
}
